#include "..\C-Engine\CHeader.hpp"

#include "GScript.hpp"

void Control::Start()
{
    etat = 0;
    GetObject()->AddRigibody();

    if(!mini)
     {
         GetObject()->GetRigibody()->SetMass(7.25);
         SetXY( 0 , 12);
     }
     else
     {
         GetObject()->GetRigibody()->SetMass(1);
         SetXY( 0 , 8);
     }

    xmax = (GetEngine()->GetMap()->nbtiles_largeur_monde - 1) * GetEngine()->GetMap()->LARGEUR_TILE ;

    practice = false;
    ptime = 0;
    spawnx = GetX();
    spawny = GetY();

    particule = false;
    usebar = false;
    useautocheck = true;
    useautoretry = false;

    waitingjump = false;

     time = 0;
     jump = 0;
     attemp = 0;


}

void Control::End()
{
    GetEngine()->StopGame();
    UserSave->UserInfo->nbjump += jump;
    UserSave->UserInfo->nbattemp += attemp + 1;
    UserSave->UserInfo->nbtime += time;
}

void Control::UpdateEverySecond()
{
    if(practice) ptime ++;
    time ++;

}

void Control::Update()
{

    static const unsigned char SP[]={0xff, 0xff,};
    static const unsigned char CP[]={0x27, 0x57, 0x8f, 0xaf, 0xaf, 0x8f, 0x57, 0x27, };

    static Sprite S_Particule(SP, 2 , 2);
    static Animation A_Particule(S_Particule);

    static Sprite S_CheckPoint(CP, 5 , 8);
    static Animation A_CheckPoint(S_CheckPoint);

    bool isground = GetObject()->GetRigibody()->CollisionDecor(GetX() , GetY() - 1);

    if(!GetObject()->GetRigibody()->CollisionDecor(GetX() + 1 , GetY())) Move(3,0);//Dplacement
    else Die();

    if(isground)particule = false;

    if(practice)
    {
        if(ptime > 2 && ( isground && etat == 0|| etat == 1) && useautocheck)
        {
            spawnx = GetX();
            spawny = GetY();
            ptime = 0;

            spawnetat = etat;

            Object * Buffer = new Object;
            Buffer->GetTransforms()->SetXY(GetX(),GetY() + 2);
            Buffer->GetRender()->SetRender(A_CheckPoint);
            GetEngine()->AddObject(Buffer);
        }
    }

    if(GetObject()->CollisionTag("Pic")) Die();//Mort

    if(GetObject()->CollisionTag("PC"))etat = 0;
    if(GetObject()->CollisionTag("PN"))etat = 1;

    switch(etat)
    {
        case 0:
            if(!mini)GetObject()->GetRigibody()->SetMass(7.25);
            else GetObject()->GetRigibody()->SetMass(12);
            SetIt(0);

            if(!isground)GetObject()->GetRender()->SetDirection( GetObject()->GetRender()->GetDirection() - 10);//Rotation
            else
            {
                if(GetObject()->GetRender()->GetDirection() < 45 || GetObject()->GetRender()->GetDirection() > 324)GetObject()->GetRender()->SetDirection(0);
                if(GetObject()->GetRender()->GetDirection() > 44  && GetObject()->GetRender()->GetDirection() < 125)GetObject()->GetRender()->SetDirection(90);
                if(GetObject()->GetRender()->GetDirection() > 124 && GetObject()->GetRender()->GetDirection() < 235)GetObject()->GetRender()->SetDirection(180);
                if(GetObject()->GetRender()->GetDirection() > 234 && GetObject()->GetRender()->GetDirection() < 325)GetObject()->GetRender()->SetDirection(270);
            }

            if(input_press(K_SHIFT) && isground)
                {
                    if(!mini)GetObject()->GetRigibody()->GetBody()->velocity.y = 68;
                    else GetObject()->GetRigibody()->GetBody()->velocity.y = 74;
                    jump++;
                    waitingjump = false;
                }
            if(GetObject()->CollisionTag("Jump"))
                {
                    if(!mini)GetObject()->GetRigibody()->GetBody()->velocity.y = 95;
                    else GetObject()->GetRigibody()->GetBody()->velocity.y = 110;
                    particule = true;
                    jump++;
                }

            if(input_trigger(K_SHIFT) && !isground)waitingjump = true;
            if(input_release(K_SHIFT))waitingjump = false;

            if(waitingjump && GetObject()->CollisionTag("DJ"))
                {
                    if(!mini)GetObject()->GetRigibody()->GetBody()->velocity.y = 68;
                    else GetObject()->GetRigibody()->GetBody()->velocity.y = 74;
                    particule = true;
                    waitingjump = false;
                }

            GetEngine()->MiddleScreen(GetX()  + 50 , GetY() +4);
        break;
        case 1:
            GetObject()->GetRigibody()->SetMass(3);
            SetIt(1);

            if(input_press(K_SHIFT))
            {
                GetObject()->GetRigibody()->GetBody()->acceleration.y = 90;
                if(GetObject()->GetRigibody()->GetBody()->velocity.y > 35)GetObject()->GetRigibody()->GetBody()->velocity.y = 35;
                if(GetObject()->GetRigibody()->GetBody()->velocity.y < -20)GetObject()->GetRigibody()->GetBody()->velocity.y = -20;
            }
            else
            {
                if(GetObject()->GetRigibody()->GetBody()->velocity.y > 20)GetObject()->GetRigibody()->GetBody()->velocity.y = 20;
                if(GetObject()->GetRigibody()->GetBody()->velocity.y < -35)GetObject()->GetRigibody()->GetBody()->velocity.y = -35;
            }



            GetObject()->GetRender()->SetDirection( GetObject()->GetRigibody()->GetBody()->velocity.y);

            GetEngine()->MiddleScreen(GetX()  + 51 , GetY() + 4);

            particule = true;

            break;
    }

    if(particule)
    {
            Object * Buffer = new Object;
            Buffer->GetTransforms()->SetXY(GetX()- 2 , GetY()+3);
            Buffer->GetRender()->SetRender(A_Particule);
            GetEngine()->AddObject(Buffer);
    }

    if(usebar)
    {
        ML_rectangle(23,2,103,4,1,ML_BLACK,ML_WHITE);
        ML_line(24,3,24 + GetX()*80/xmax,3,ML_BLACK );
    }

    if(GetX() < 100)
    {
        const unsigned char sattempt[]={0x78, 0x7f, 0x3f, 0x9f, 0xc2, 0x38, 0x3e, 0x3f, 0xff, 0x78, 0x7f, 0x3f, 0x9f, 0x82, 0x38, 0x3e, 0x3f, 0xff, 0xdc, 0x3c, 0x1e, 0x38, 0x7, 0x7c, 0x67, 0x1e, 0x7f, 0xcc, 0x3c, 0x1e, 0x38, 0x7, 0xde, 0x67, 0x1e, 0x7f, 0xcc, 0x1c, 0xe, 0x3e, 0xf, 0xce, 0x7f, 0xe, 0x7f, 0xcc, 0x1c, 0xe, 0x3f, 0xe, 0xce, 0x7e, 0xe, 0x7f, 0xfc, 0x1c, 0xe, 0x38, 0xe, 0xce, 0x78, 0xe, 0x7f, 0xfc, 0x18, 0xc, 0x38, 0xc, 0x4e, 0x60, 0xc, 0x7f, 0xcc, 0x18, 0xc, 0x3f, 0xc, 0x4c, 0x60, 0xc, 0x7f, 0xcc, 0x8, 0x4, 0x1f, 0x8c, 0x1c, 0x60, 0x4, 0x7f, 0x40, 0x0, 0x0, 0x0, 0x0, 0x18, 0x20, 0x0, 0x7f, 0x40, 0x0, 0x0, 0x0, 0x0, 0x18, 0x20, 0x0, 0x7f, 0x40, 0x0, 0x0, 0x0, 0x0, 0x10, 0x20, 0x0, 0x7f, };
        const unsigned char snombre[]={0x31, 0x79, 0xcd, 0xcd, 0x8d, 0x85, 0xc5, 0x45, 0x79, 0x39, 0x19, 0x79, 0xf9, 0xd9, 0x19, 0x19, 0x19, 0x39, 0x31, 0x21, 0x31, 0xf9, 0xd, 0xd, 0x1d, 0x7d, 0xe1, 0x81, 0xfd, 0x79, 0x79, 0xfd, 0xcd, 0xd, 0x5, 0x3d, 0x3d, 0xd, 0x3d, 0xf9, 0x41, 0xc1, 0xc1, 0xc9, 0xdd, 0xfd, 0x39, 0x19, 0x19, 0x31, 0x3d, 0x79, 0xc1, 0xc1, 0xe1, 0x39, 0xd, 0xd, 0x1d, 0xf9, 0x3d, 0x79, 0xc1, 0xc1, 0xe1, 0x99, 0x8d, 0xc5, 0xcd, 0x79, 0x39, 0xfd, 0xf, 0x7, 0x35, 0x7d, 0xd, 0xd, 0x31, 0x71, 0x79, 0xfd, 0xcd, 0xcd, 0x85, 0xfd, 0xcd, 0x8d, 0xfd, 0x79, 0x79, 0xcd, 0x8d, 0xc5, 0x65, 0x1d, 0xd, 0xd, 0x79, 0xf1, };

        ML_bmp_or_cl(sattempt , 10 , 10 + GetEngine()->GetScreen()->min.y ,65 , 13);

        if(attemp / 100 > 0)
        {
            ML_bmp_or_cl(snombre + 10 * (attemp / 100), 85 , 10 + GetEngine()->GetScreen()->min.y ,7,10);
            ML_bmp_or_cl(snombre + 10 * ((attemp % 100) / 10), 95 , 10 + GetEngine()->GetScreen()->min.y ,7,10);
            ML_bmp_or_cl(snombre + 10 * (attemp % 10), 105 , 10 + GetEngine()->GetScreen()->min.y ,7,10);
        }
        else
        {
            ML_bmp_or_cl(snombre + 10 * ((attemp % 100) / 10), 85 , 10 + GetEngine()->GetScreen()->min.y ,7,10);
            ML_bmp_or_cl(snombre + 10 * (attemp % 10) , 95, 10 + GetEngine()->GetScreen()->min.y ,7,10);
        }

    }
    if(input_trigger(K_EXIT))Pause();
}

void Control::Die()
{
    int avancement = GetX()*100/xmax;

    if(!practice)
    {
        if( avancement > UserSave->TabLevel[nlevel-1]->normalprogress)UserSave->TabLevel[nlevel-1]->normalprogress = avancement;
    }
    else
    {
        if( avancement > UserSave->TabLevel[nlevel-1]->practiseprogress)UserSave->TabLevel[nlevel-1]->practiseprogress = avancement;
    }


    int stop = GetEngine()->GetNbObject();
    ptime = 0;

    for(int i = 1; i <  stop ; i++)
    {
            GetEngine()->DelObject(GetEngine()->GetListeObject()[i]);
            i--;
            stop --;
    }

    bool cinematic = true;

    int x = GetEngine()->GetListeObject()[0]->GetTransforms()->GetRelativeX();
    int y = GetEngine()->GetListeObject()[0]->GetTransforms()->GetRelativeY();
    int dtime = 0;
    int choix = 0;

    const unsigned char S1[]={0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x60, 0xf, 0x0, 0x60, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, };
    const unsigned char S2[]={0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0xf0, 0xf, 0x0, 0x90, 0xf, 0x0, 0x90, 0xf, 0x0, 0xf0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, };
    const unsigned char S3[]={0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x40, 0xf, 0x2, 0x4, 0xf, 0x0, 0xf0, 0xf, 0x1, 0x8, 0xf, 0x9, 0x8, 0xf, 0x1, 0x8, 0xf, 0x1, 0x8, 0xf, 0x0, 0xf0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, };
    const unsigned char S4[]={0x6, 0x0, 0xf, 0x6, 0x0, 0xf, 0x0, 0x60, 0xf, 0x18, 0x61, 0x8f, 0x18, 0x1, 0x8f, 0x3, 0xfc, 0xf, 0x4, 0x2, 0xf, 0x4, 0x2, 0xf, 0x4, 0x2, 0xf, 0x4, 0x62, 0xf, 0x4, 0x62, 0xf, 0x4, 0x2, 0xf, 0x4, 0x2, 0xf, 0x4, 0x2, 0xf, 0x3, 0xfc, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, };
    const unsigned char S5[]={0x3, 0x19, 0x8f, 0x3, 0x19, 0x8f, 0x30, 0x0, 0xf, 0x33, 0xfc, 0xf, 0xc, 0x3, 0xf, 0x8, 0x1, 0xf, 0x10, 0x0, 0x8f, 0x10, 0x0, 0x8f, 0x10, 0x60, 0x8f, 0x10, 0x90, 0x8f, 0x10, 0x90, 0x8f, 0x10, 0x60, 0x8f, 0x10, 0x0, 0x8f, 0x10, 0x0, 0x8f, 0x8, 0x1, 0xf, 0xc, 0x3, 0xf, 0x3, 0xfc, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, 0x0, 0x0, 0xf, };

    ML_clear_vram();

    GetEngine()->GetMap()->AfficherMap();

    ML_display_vram();

    while(cinematic == true)
    {

        dtime ++;

        if(dtime < 5)choix = 0;
            else if(dtime < 10)choix = 1;
            else if(dtime < 15)choix = 2;
            else if(dtime < 20)choix = 3;
            else if(dtime < 25)choix = 4;

        ML_clear_vram();

        if(dtime > 25) cinematic = false;

        GetEngine()->GetMap()->AfficherMap();

        switch(choix)
        {
            case 0: ML_bmp_or(S1,x-2,47 - y,20,20); break;
            case 1: ML_bmp_or(S2,x-2,47 - y,20,20); break;
            case 2: ML_bmp_or(S3,x-2,47 - y,20,20); break;
            case 3: ML_bmp_or(S4,x-2,47 - y,20,20); break;
            case 4: ML_bmp_or(S5,x-2,47 - y,20,20); break;
        }


       if(usebar)
        {
            ML_rectangle(23,2,103,4,1,ML_BLACK,ML_WHITE);
            ML_line(24,3,24 + GetX()*80/xmax,3,ML_BLACK );
        }

        ML_display_vram();

        Sleep(10);
    }


    if(!useautoretry)EndScreen();

    attemp ++;

    if(practice)
    {
        etat = spawnetat;
        SetXY( spawnx , spawny);
    }
    else
    {
        etat = 0;
        SetXY( 0 , 12);
    }

    if(!mini)
    {
        for(int i = 0; i < 10 ; i++)
        {
            EC->SetDecor(((int)GetEngine()->GetListeObject()[0]->GetTransforms()->GetX() / 12) + i);
        }
    }
    else
    {
        for(int i = 0; i < 15 ; i++)
        {
            EC->SetDecor(((int)GetEngine()->GetListeObject()[0]->GetTransforms()->GetX() / 8) + i);
        }
    }


}

void Control::EndScreen()
{
    bool end = false;
    int choix = 0;


    const unsigned char srestart[]={0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x14, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x28, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x8, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x27, 0x77, 0x57, 0x70, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x52, 0x24, 0x75, 0x20, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x72, 0x26, 0x57, 0x20, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x52, 0x24, 0x54, 0x20, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x52, 0x27, 0x54, 0x20, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x3, 0xaa, 0xbb, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x1, 0x2b, 0xaa, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x1, 0x2a, 0xbb, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x1, 0x2a, 0xa0, 0xa0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x3, 0x3a, 0xa3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x3, 0xaa, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x1, 0xe, 0x88, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x1, 0x2a, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x1, 0x2a, 0x88, 0x0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x1, 0x2a, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0xf, 0x80, 0x0, 0x0, 0x0, 0x0, 0x3, 0xe0, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0xc, 0x18, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x40, 0x10, 0x0, 0x0, 0x0, 0x0, 0x10, 0x4, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0xa, 0x0, 0x80, 0x8, 0x0, 0x0, 0x0, 0x0, 0x20, 0x2, 0x0, 0x50, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0x8f, 0x8f, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x3, 0xff, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x41, 0x10, 0x44, 0x0, 0x80, 0x2, 0x0, 0x42, 0xf1, 0x2, 0x8, 0x0, 0x0, 0x0, 0x0, 0x10, 0x41, 0x10, 0x44, 0x0, 0x80, 0x2, 0x0, 0x40, 0x1, 0x2, 0x8, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xc1, 0x10, 0x44, 0x0, 0x80, 0x2, 0x0, 0x42, 0xf1, 0x3, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x41, 0x10, 0xe4, 0x0, 0x80, 0x2, 0x0, 0x40, 0x1, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x41, 0x10, 0x44, 0x0, 0x80, 0x2, 0x0, 0x42, 0xf1, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0x90, 0xf, 0xff, 0x80, 0x3, 0xff, 0xe0, 0x3, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8f, 0x8, 0x0, 0x80, 0x2, 0x0, 0x20, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x10, 0x0, 0xff, 0xfe, 0x0, 0x10, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30, 0x60, 0x0, 0x0, 0x0, 0x0, 0xc, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0x80, 0x0, 0x0, 0x0, 0x0, 0x3, 0xe0, 0x0, 0x0, 0x0, 0x0, };

    const unsigned char N5[]={0x7, 0xc1, 0x1f, 0xf1, 0x3f, 0xf9, 0x7f, 0xfd, 0x7f, 0xfd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xfd, 0x7f, 0xfd, 0x3f, 0xf9, 0x1f, 0xf1, 0x7, 0xc1, };
    const unsigned char P10[]={0xf8, 0x3f, 0xe7, 0xcf, 0xdf, 0xf7, 0xbf, 0xfb, 0xbf, 0xfb, 0x7a, 0x1d, 0x7f, 0xfd, 0x7a, 0x1d, 0x7f, 0xfd, 0x7a, 0x1d, 0xbf, 0xfb, 0xbf, 0xfb, 0xdf, 0xf7, 0xe7, 0xcf, 0xf8, 0x3f, };
    const unsigned char P11[]={0xf8, 0x3f, 0xe7, 0xcf, 0xdf, 0xf7, 0xbf, 0xfb, 0x38, 0x39, 0x77, 0xdd, 0x77, 0xdd, 0x77, 0xdd, 0x77, 0x8d, 0x77, 0xdd, 0x37, 0xf9, 0xb8, 0x7b, 0xdf, 0xf7, 0xe7, 0xcf, 0xf8, 0x3f, };

    while(end == false)
    {
        ML_clear_vram();

        input_update();

        ML_bmp_or(srestart , 0 ,0 , 128 , 64);

        PrintV(75,18,attemp);
        PrintV(65,31,jump);
        PrintV(55,38,time/60);
        PrintV(75,38,time%60);

        ML_line(26,26,26 + GetX()*75/xmax,26,ML_BLACK );


        if(input_any_key())
        {
            if(input_trigger(K_RIGHT))choix ++;
            if(input_trigger(K_LEFT))choix --;

            if(input_trigger(K_EXIT))return;

            if(choix < 0)choix = 1;
            if(choix > 1)choix = 0;


            if(input_trigger(K_EXE) || input_trigger(K_SHIFT))
            {
                switch(choix)
                {
                    case 0:  end = true;break;
                    case 1:  End(); end = true;break;
                }
            }
        }

        switch(choix)
                {
                    case 0: ML_bmp_or(N5 , 31,49 , 15 ,15); ML_bmp_and(P11 , 31,49 , 16 ,16); break;
                    case 1: ML_bmp_or(N5 , 81,49 , 15 ,15); ML_bmp_and(P10 , 81,49 , 16 ,16); break;
                }

        ML_display_vram();
    }

}

void Control::Pause()
{
    const unsigned char P8[]={0xff, 0x1, 0xff, 0xfc, 0xfe, 0x7f, 0xfb, 0xff, 0xbf, 0xf7, 0xff, 0xdf, 0xef, 0xdf, 0xef, 0xdf, 0xaf, 0xf7, 0xbf, 0xb7, 0xfb, 0xbf, 0xbb, 0xfb, 0x7f, 0xbd, 0xfd, 0x7f, 0xbe, 0xfd, 0x7f, 0xbf, 0x7d, 0x7f, 0xbf, 0xbd, 0x7f, 0xbf, 0x7d, 0x7f, 0xbe, 0xfd, 0x7f, 0xbd, 0xfd, 0xbf, 0xbb, 0xfb, 0xbf, 0xb7, 0xfb, 0xdf, 0xaf, 0xf7, 0xef, 0xdf, 0xef, 0xf7, 0xff, 0xdf, 0xf9, 0xff, 0x3f, 0xfe, 0xfe, 0xff, 0xff, 0x1, 0xff, };
    const unsigned char P9[]={0xf8, 0x3f, 0xe7, 0xcf, 0xde, 0xf7, 0xbd, 0x7b, 0xbb, 0xbb, 0x7b, 0xbd, 0x7a, 0xbd, 0x7a, 0xbd, 0x7a, 0xbd, 0x7a, 0xbd, 0xbb, 0xbb, 0xbd, 0x7b, 0xde, 0xf7, 0xe7, 0xcf, 0xf8, 0x3f, };
    const unsigned char P10[]={0xf8, 0x3f, 0xe7, 0xcf, 0xdf, 0xf7, 0xbf, 0xfb, 0xbf, 0xfb, 0x7a, 0x1d, 0x7f, 0xfd, 0x7a, 0x1d, 0x7f, 0xfd, 0x7a, 0x1d, 0xbf, 0xfb, 0xbf, 0xfb, 0xdf, 0xf7, 0xe7, 0xcf, 0xf8, 0x3f, };

    const unsigned char N4[]={0x0, 0xfe, 0x1, 0x3, 0xff, 0x81, 0x7, 0xff, 0xc1, 0xf, 0xff, 0xe1, 0x1f, 0xff, 0xf1, 0x3f, 0xff, 0xf9, 0x7f, 0xff, 0xfd, 0x7f, 0xff, 0xfd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xfd, 0x7f, 0xff, 0xfd, 0x3f, 0xff, 0xf9, 0x1f, 0xff, 0xf1, 0xf, 0xff, 0xe1, 0x7, 0xff, 0xc1, 0x1, 0xff, 0x1, 0x0, 0xfe, 0x1, };
    const unsigned char N5[]={0x7, 0xc1, 0x1f, 0xf1, 0x3f, 0xf9, 0x7f, 0xfd, 0x7f, 0xfd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xfd, 0x7f, 0xfd, 0x3f, 0xf9, 0x1f, 0xf1, 0x7, 0xc1, };

     const unsigned char spause[]={0x0, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x3e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x78, 0x0, 0x0, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x97, 0x74, 0x5d, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0xd5, 0x56, 0xd5, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc0, 0xc, 0x0, 0x0, 0x0, 0x0, 0x0, 0xb5, 0x75, 0x5d, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x95, 0x64, 0x55, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x97, 0x54, 0x55, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x40, 0x0, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x2, 0x80, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x2, 0x80, 0x0, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x3, 0xbb, 0xbb, 0xae, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x2, 0xaa, 0xa1, 0x28, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x3, 0xbb, 0xa1, 0x28, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x2, 0x32, 0xa1, 0x28, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x2, 0x2a, 0xb9, 0x2e, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x1, 0x80, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x1, 0x80, 0x0, 0x1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x1, 0x2, 0x1, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x18, 0x30, 0x0, 0x2, 0x5, 0x0, 0x80, 0x0, 0x18, 0x30, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x21, 0x8, 0x0, 0x4, 0x4, 0x80, 0x40, 0x0, 0x20, 0x8, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x42, 0x84, 0x0, 0x4, 0x4, 0x40, 0x40, 0x0, 0x40, 0x4, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x44, 0x44, 0x0, 0x8, 0x4, 0x20, 0x20, 0x0, 0x40, 0x4, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x84, 0x42, 0x0, 0x8, 0x4, 0x10, 0x20, 0x0, 0x85, 0xe2, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x85, 0x42, 0x0, 0x8, 0x4, 0x8, 0x20, 0x0, 0x80, 0x2, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x85, 0x42, 0x0, 0x8, 0x4, 0x4, 0x20, 0x0, 0x85, 0xe2, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x85, 0x42, 0x0, 0x8, 0x4, 0x8, 0x20, 0x0, 0x80, 0x2, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x85, 0x42, 0x0, 0x8, 0x4, 0x10, 0x20, 0x0, 0x85, 0xe2, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x44, 0x44, 0x0, 0x8, 0x4, 0x20, 0x20, 0x0, 0x40, 0x4, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x42, 0x84, 0x0, 0x4, 0x4, 0x40, 0x40, 0x0, 0x40, 0x4, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x21, 0x8, 0x0, 0x4, 0x4, 0x80, 0x40, 0x0, 0x20, 0x8, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x18, 0x30, 0x0, 0x2, 0x5, 0x0, 0x80, 0x0, 0x18, 0x30, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x1, 0x2, 0x1, 0x0, 0x0, 0x7, 0xc0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x80, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x60, 0xc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x10, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xe0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x0, 0x3c, 0x6a, 0xe6, 0xa0, 0x3, 0xce, 0xee, 0xea, 0x0, 0x1e, 0x33, 0xb8, 0x0, 0x1, 0x80, 0x0, 0x24, 0x8a, 0x88, 0xa0, 0x2, 0x4a, 0x84, 0xaa, 0x0, 0x12, 0x2a, 0xa8, 0x0, 0x1, 0x80, 0x0, 0x24, 0x8e, 0xc8, 0xc0, 0x2, 0x4e, 0xc4, 0xe4, 0x0, 0x12, 0x3b, 0xb8, 0x0, 0x1, 0x80, 0x0, 0x3c, 0x8a, 0x88, 0xa0, 0x3, 0xcc, 0x84, 0xc4, 0x0, 0x1e, 0x2a, 0xb0, 0x0, 0x2, 0x40, 0x0, 0x0, 0x6a, 0xe6, 0xa0, 0x0, 0xa, 0xe4, 0xa4, 0x0, 0x0, 0x32, 0xa8, 0x0, 0x2, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x8, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x30, 0x6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x0, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3c, 0x0, 0x0, 0x7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc0, 0x0, };

    bool end = false;
    int choix = 1;

    while(end == false)
    {
        ML_clear_vram();

        input_update();

        ML_bmp_or(spause , 0 ,0 , 128 , 64);

        ML_line(23,9,23 + (UserSave->TabLevel[nlevel-1]->normalprogress * 75 / 100 ) ,9,ML_BLACK);

        ML_line(23,19,23 + (UserSave->TabLevel[nlevel-1]->practiseprogress * 75 / 100 ) ,19,ML_BLACK);

        if(useautocheck)ML_rectangle(19,53,20,54,1,ML_BLACK,ML_BLACK);
        if(useautoretry)ML_rectangle(55,53,56,54,1,ML_BLACK,ML_BLACK);
        if(usebar)ML_rectangle(92,53,93,54,1,ML_BLACK,ML_BLACK);

        if(input_any_key())
        {
            if(input_trigger(K_RIGHT))choix ++;
            if(input_trigger(K_LEFT))choix --;

            if(input_trigger(K_UP))choix -= 3;
            if(input_trigger(K_DOWN))choix += 3;

            if(input_trigger(K_EXIT))return;

            if(choix < 0)choix = 5;
            if(choix > 5)choix = 0;


            if(input_trigger(K_EXE) || input_trigger(K_SHIFT))
            {
                switch(choix)
                {
                    case 0:  practice = true; end = true;break;
                    case 1:  end = true;break;
                    case 2:  End(); end = true; break;
                    case 3:  if(useautocheck == false)useautocheck = true;else useautocheck = false;break;
                    case 4:  if(useautoretry == false)useautoretry = true;else useautoretry = false;break;
                    case 5:  if(usebar == false)usebar = true;else usebar =false; break;
                }
            }
        }

        switch(choix)
                {
                    case 0: ML_bmp_or(N5 , 24,26 , 15 ,15); ML_bmp_and(P9 , 24,26 , 16 ,16); break;
                    case 1: ML_bmp_or(N4 , 52,22 , 23 ,23); ML_bmp_and(P8 , 52,22 , 24 ,24); break;
                    case 2: ML_bmp_or(N5 , 88,26 , 15 ,15); ML_bmp_and(P10 , 88,26 , 16 ,16); break;
                    case 3: ML_line(24,58,42,58,ML_BLACK); break;
                    case 4: ML_line(60,58,78,58,ML_BLACK); break;
                    case 5: ML_line(98,58,108,58,ML_BLACK); break;

                }

        ML_display_vram();
    }

}

